<?php
/**
 * CustomerFavoritesApi
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CrmClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * CRM
 *
 * Управление клиентами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CrmClient\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Ensi\CrmClient\ApiException;
use Ensi\CrmClient\Configuration;
use Ensi\CrmClient\HeaderSelector;
use Ensi\CrmClient\ObjectSerializer;

/**
 * CustomerFavoritesApi Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CrmClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CustomerFavoritesApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $host_index (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $host_index = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $host_index;
    }

    /**
     * Set the host index
     *
     * @param  int Host index (required)
     */
    public function setHostIndex($host_index)
    {
        $this->hostIndex = $host_index;
    }

    /**
     * Get the host index
     *
     * @return Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation clearCustomerFavorites
     *
     * Удаление всех товаров из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\ClearCustomerFavoritesRequest $clear_customer_favorites_request clear_customer_favorites_request (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CrmClient\Dto\EmptyDataResponse|\Ensi\CrmClient\Dto\ErrorResponse|\Ensi\CrmClient\Dto\ErrorResponse
     */
    public function clearCustomerFavorites($clear_customer_favorites_request)
    {
        list($response) = $this->clearCustomerFavoritesWithHttpInfo($clear_customer_favorites_request);
        return $response;
    }

    /**
     * Operation clearCustomerFavoritesWithHttpInfo
     *
     * Удаление всех товаров из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\ClearCustomerFavoritesRequest $clear_customer_favorites_request (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CrmClient\Dto\EmptyDataResponse|\Ensi\CrmClient\Dto\ErrorResponse|\Ensi\CrmClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function clearCustomerFavoritesWithHttpInfo($clear_customer_favorites_request)
    {
        $request = $this->clearCustomerFavoritesRequest($clear_customer_favorites_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CrmClient\Dto\EmptyDataResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\EmptyDataResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CrmClient\Dto\EmptyDataResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\EmptyDataResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation clearCustomerFavoritesAsync
     *
     * Удаление всех товаров из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\ClearCustomerFavoritesRequest $clear_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function clearCustomerFavoritesAsync($clear_customer_favorites_request)
    {
        return $this->clearCustomerFavoritesAsyncWithHttpInfo($clear_customer_favorites_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation clearCustomerFavoritesAsyncWithHttpInfo
     *
     * Удаление всех товаров из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\ClearCustomerFavoritesRequest $clear_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function clearCustomerFavoritesAsyncWithHttpInfo($clear_customer_favorites_request)
    {
        $returnType = '\Ensi\CrmClient\Dto\EmptyDataResponse';
        $request = $this->clearCustomerFavoritesRequest($clear_customer_favorites_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'clearCustomerFavorites'
     *
     * @param  \Ensi\CrmClient\Dto\ClearCustomerFavoritesRequest $clear_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function clearCustomerFavoritesRequest($clear_customer_favorites_request)
    {
        // verify the required parameter 'clear_customer_favorites_request' is set
        if ($clear_customer_favorites_request === null || (is_array($clear_customer_favorites_request) && count($clear_customer_favorites_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $clear_customer_favorites_request when calling clearCustomerFavorites'
            );
        }

        $resourcePath = '/customers/favorites:clear';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($clear_customer_favorites_request)) {
            $_tempBody = $clear_customer_favorites_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation createCustomerFavorite
     *
     * Создание объекта типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\CustomerFavoriteForCreate $customer_favorite_for_create customer_favorite_for_create (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CrmClient\Dto\CustomerFavoriteResponse|\Ensi\CrmClient\Dto\ErrorResponse|\Ensi\CrmClient\Dto\ErrorResponse
     */
    public function createCustomerFavorite($customer_favorite_for_create)
    {
        list($response) = $this->createCustomerFavoriteWithHttpInfo($customer_favorite_for_create);
        return $response;
    }

    /**
     * Operation createCustomerFavoriteWithHttpInfo
     *
     * Создание объекта типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\CustomerFavoriteForCreate $customer_favorite_for_create (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CrmClient\Dto\CustomerFavoriteResponse|\Ensi\CrmClient\Dto\ErrorResponse|\Ensi\CrmClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function createCustomerFavoriteWithHttpInfo($customer_favorite_for_create)
    {
        $request = $this->createCustomerFavoriteRequest($customer_favorite_for_create);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CrmClient\Dto\CustomerFavoriteResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\CustomerFavoriteResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CrmClient\Dto\CustomerFavoriteResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\CustomerFavoriteResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation createCustomerFavoriteAsync
     *
     * Создание объекта типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\CustomerFavoriteForCreate $customer_favorite_for_create (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerFavoriteAsync($customer_favorite_for_create)
    {
        return $this->createCustomerFavoriteAsyncWithHttpInfo($customer_favorite_for_create)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation createCustomerFavoriteAsyncWithHttpInfo
     *
     * Создание объекта типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\CustomerFavoriteForCreate $customer_favorite_for_create (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function createCustomerFavoriteAsyncWithHttpInfo($customer_favorite_for_create)
    {
        $returnType = '\Ensi\CrmClient\Dto\CustomerFavoriteResponse';
        $request = $this->createCustomerFavoriteRequest($customer_favorite_for_create);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'createCustomerFavorite'
     *
     * @param  \Ensi\CrmClient\Dto\CustomerFavoriteForCreate $customer_favorite_for_create (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function createCustomerFavoriteRequest($customer_favorite_for_create)
    {
        // verify the required parameter 'customer_favorite_for_create' is set
        if ($customer_favorite_for_create === null || (is_array($customer_favorite_for_create) && count($customer_favorite_for_create) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $customer_favorite_for_create when calling createCustomerFavorite'
            );
        }

        $resourcePath = '/customers/favorites';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($customer_favorite_for_create)) {
            $_tempBody = $customer_favorite_for_create;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation deleteProductFromCustomerFavorites
     *
     * Удаление товара из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\DeleteProductFromCustomerFavoritesRequest $delete_product_from_customer_favorites_request delete_product_from_customer_favorites_request (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CrmClient\Dto\EmptyDataResponse|\Ensi\CrmClient\Dto\ErrorResponse|\Ensi\CrmClient\Dto\ErrorResponse
     */
    public function deleteProductFromCustomerFavorites($delete_product_from_customer_favorites_request)
    {
        list($response) = $this->deleteProductFromCustomerFavoritesWithHttpInfo($delete_product_from_customer_favorites_request);
        return $response;
    }

    /**
     * Operation deleteProductFromCustomerFavoritesWithHttpInfo
     *
     * Удаление товара из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\DeleteProductFromCustomerFavoritesRequest $delete_product_from_customer_favorites_request (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CrmClient\Dto\EmptyDataResponse|\Ensi\CrmClient\Dto\ErrorResponse|\Ensi\CrmClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function deleteProductFromCustomerFavoritesWithHttpInfo($delete_product_from_customer_favorites_request)
    {
        $request = $this->deleteProductFromCustomerFavoritesRequest($delete_product_from_customer_favorites_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CrmClient\Dto\EmptyDataResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\EmptyDataResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 404:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CrmClient\Dto\EmptyDataResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\EmptyDataResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 404:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation deleteProductFromCustomerFavoritesAsync
     *
     * Удаление товара из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\DeleteProductFromCustomerFavoritesRequest $delete_product_from_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteProductFromCustomerFavoritesAsync($delete_product_from_customer_favorites_request)
    {
        return $this->deleteProductFromCustomerFavoritesAsyncWithHttpInfo($delete_product_from_customer_favorites_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation deleteProductFromCustomerFavoritesAsyncWithHttpInfo
     *
     * Удаление товара из списка избранного клиента
     *
     * @param  \Ensi\CrmClient\Dto\DeleteProductFromCustomerFavoritesRequest $delete_product_from_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function deleteProductFromCustomerFavoritesAsyncWithHttpInfo($delete_product_from_customer_favorites_request)
    {
        $returnType = '\Ensi\CrmClient\Dto\EmptyDataResponse';
        $request = $this->deleteProductFromCustomerFavoritesRequest($delete_product_from_customer_favorites_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'deleteProductFromCustomerFavorites'
     *
     * @param  \Ensi\CrmClient\Dto\DeleteProductFromCustomerFavoritesRequest $delete_product_from_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function deleteProductFromCustomerFavoritesRequest($delete_product_from_customer_favorites_request)
    {
        // verify the required parameter 'delete_product_from_customer_favorites_request' is set
        if ($delete_product_from_customer_favorites_request === null || (is_array($delete_product_from_customer_favorites_request) && count($delete_product_from_customer_favorites_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $delete_product_from_customer_favorites_request when calling deleteProductFromCustomerFavorites'
            );
        }

        $resourcePath = '/customers/favorites:delete-product';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($delete_product_from_customer_favorites_request)) {
            $_tempBody = $delete_product_from_customer_favorites_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation searchCustomerFavorite
     *
     * Поиск объектов типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\SearchCustomerFavoritesRequest $search_customer_favorites_request search_customer_favorites_request (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse|\Ensi\CrmClient\Dto\ErrorResponse
     */
    public function searchCustomerFavorite($search_customer_favorites_request)
    {
        list($response) = $this->searchCustomerFavoriteWithHttpInfo($search_customer_favorites_request);
        return $response;
    }

    /**
     * Operation searchCustomerFavoriteWithHttpInfo
     *
     * Поиск объектов типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\SearchCustomerFavoritesRequest $search_customer_favorites_request (required)
     *
     * @throws \Ensi\CrmClient\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse|\Ensi\CrmClient\Dto\ErrorResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function searchCustomerFavoriteWithHttpInfo($search_customer_favorites_request)
    {
        $request = $this->searchCustomerFavoriteRequest($search_customer_favorites_request);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody()
                );
            }

            $responseBody = $response->getBody();
            switch($statusCode) {
                case 200:
                    if ('\Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\Ensi\CrmClient\Dto\ErrorResponse' === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, '\Ensi\CrmClient\Dto\ErrorResponse', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse';
            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = (string) $responseBody;
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializer::deserialize(
                        $e->getResponseBody(),
                        '\Ensi\CrmClient\Dto\ErrorResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation searchCustomerFavoriteAsync
     *
     * Поиск объектов типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\SearchCustomerFavoritesRequest $search_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchCustomerFavoriteAsync($search_customer_favorites_request)
    {
        return $this->searchCustomerFavoriteAsyncWithHttpInfo($search_customer_favorites_request)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation searchCustomerFavoriteAsyncWithHttpInfo
     *
     * Поиск объектов типа CustomerFavorite
     *
     * @param  \Ensi\CrmClient\Dto\SearchCustomerFavoritesRequest $search_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Promise\PromiseInterface
     */
    public function searchCustomerFavoriteAsyncWithHttpInfo($search_customer_favorites_request)
    {
        $returnType = '\Ensi\CrmClient\Dto\SearchCustomerFavoritesResponse';
        $request = $this->searchCustomerFavoriteRequest($search_customer_favorites_request);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    $responseBody = $response->getBody();
                    if ($returnType === '\SplFileObject') {
                        $content = $responseBody; //stream goes to serializer
                    } else {
                        $content = (string) $responseBody;
                    }

                    return [
                        ObjectSerializer::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    if (!$exception instanceof RequestException) {
                        throw $exception;
                    }

                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'searchCustomerFavorite'
     *
     * @param  \Ensi\CrmClient\Dto\SearchCustomerFavoritesRequest $search_customer_favorites_request (required)
     *
     * @throws \InvalidArgumentException
     * @return \GuzzleHttp\Psr7\Request
     */
    protected function searchCustomerFavoriteRequest($search_customer_favorites_request)
    {
        // verify the required parameter 'search_customer_favorites_request' is set
        if ($search_customer_favorites_request === null || (is_array($search_customer_favorites_request) && count($search_customer_favorites_request) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $search_customer_favorites_request when calling searchCustomerFavorite'
            );
        }

        $resourcePath = '/customers/favorites:search';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;




        // body params
        $_tempBody = null;
        if (isset($search_customer_favorites_request)) {
            $_tempBody = $search_customer_favorites_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode(ObjectSerializer::sanitizeForSerialization($_tempBody));
            } else {
                $httpBody = $_tempBody;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }


        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
